import { type RenderContext } from "../../Renderer";
import { BooleanOption, type Option } from "../../RendererOptions";
import { AcronymStyleOptions } from "../../support/Acronyms";
import { TargetLanguage } from "../../TargetLanguage";
import { type StringTypeMapping } from "../../TypeBuilder";
import { type FixMeOptionsAnyType, type FixMeOptionsType } from "../../types";
import { PhpRenderer } from "./PhpRenderer";
export declare const phpOptions: {
    withGet: BooleanOption;
    fastGet: BooleanOption;
    withSet: BooleanOption;
    withClosing: BooleanOption;
    acronymStyle: import("../../RendererOptions").EnumOption<AcronymStyleOptions>;
};
export declare class PhpTargetLanguage extends TargetLanguage {
    constructor();
    protected getOptions(): Array<Option<FixMeOptionsAnyType>>;
    get supportsUnionsWithBothNumberTypes(): boolean;
    protected makeRenderer(renderContext: RenderContext, untypedOptionValues: FixMeOptionsType): PhpRenderer;
    get stringTypeMapping(): StringTypeMapping;
}
